
% callback.m -- callbacks for gui's in housekeep.m, spectra.m, and mapper.m

%
% callbacks for the housekeeping page
%

% update plot
if cflag == 1
  xv = get(xaxis,'value');
  yv = get(yaxis,'value');
  st = [];
  for i = 1:length(yv)
    x=names{xv};y=names{yv(i)};
    eval(['lx=length(data.' x ');']);
    eval(['ly=length(data.' y ');']);
    eval(['l1=length(find(isnan(data.' x ')==1));'])
    eval(['l2=length(find(isnan(data.' y ')==1));'])
    if lx == ly
      st = [st 'data.' x ',data.' y ','];
    end
    if l1 >= 1
      set(msg,'String',[num2str(l1) ' NaN''s in ' x])
    elseif l2 >= 1
      set(msg,'String',[num2str(l2) ' NaN''s in ' y])
    elseif lx ~= ly
      set(msg,'String',[x ' and ' y ' do not have the same number of elements'])
    else
      set(msg,'String','no messages')
    end
  end
  if ~isempty(st) & ~strcmp(st,'Radiance')
    eval(['h=plot(' st(1:length(st)-1) ');']);
    set(h,'Marker','.','MarkerSize',10);
    set(gca,'Fontweight','b')
    xlabel(x);ylabel(y)
    grid on
    set(get(gca,'Ylabel'),'Clipping','off')
    % add color coded curve labels
    ax = axis;
    for i = 1:length(yv)
      t=text(ax(1)+(ax(2)-ax(1))*0.05,ax(3)+(ax(4)-ax(3))*0.1*i,names{yv(i)});
      set(t,'Color',get(h(i),'Color'),'FontWeight','b','Units','norm');
    end
  end


% update x-axis editlist from x-axis text edit box
elseif cflag == 2
  st = get(xaxis2,'String');
  for i = 1:nvars
    z=names{i};
    if length(z) == length(st) & lower(z(1:length(st)))==lower(st)
      xv = i;set(xaxis,'Value',xv);set(xaxis2,'String',names{xv})
    end
  end  
  
% update y-axis editlist from y-axis text edit box
elseif cflag == 3
  st = get(yaxis2,'String');
  for i = 1:nvars
    z=names{i};
    if length(z) == length(st) & lower(z(1:length(st)))==lower(st)
      yv = i;set(yaxis,'Value',yv);set(yaxis2,'String',names{yv})
    end
  end  

% update x and y axis text edit boxes from axes editlists
elseif cflag == 4
  xv = get(xaxis,'value');
  yv = get(yaxis,'value');
  set(xaxis2,'String',names{xv});
  set(yaxis2,'String',names{yv(length(yv))});

% output section
elseif cflag == 5
  % get desired type of output
  otype = get(oub,'Value');
  % print postscript file
  if otype == 1
    figure('units','norm','pos',[0.05 .5 .25 .4],'Name','browser PS output screen')
    h1=uicontrol('Style','edit','pos',[.1 .75 .8 .1],'FontSize',14,...
	'units','norm','String','file.ps','back',[.85 .9 .85],'fore',[.2 .2 .2]);
    uicontrol('Style','Text','String','filename:','FontWeight','b',...
	'FontSize',10,'pos',[.1 .85 .8 .05],'units','norm','FontUnits','norm',...
	'back',get(gcf,'Color'),'fore',[.2 .2 .2]);
    h2 = uicontrol('style','popupmenu','units','norm','pos',[.25 .60 .5 .12],...
	'String','color|black+white','Value',1,'FontWeight','b','back',[.45 .65 .65]);
    h3 = uicontrol('style','popupmenu','units','norm','pos',[.25 .45 .5 .12],...
	'String','landscape|portrait|tall','Value',1,'FontWeight','b','back',[.45 .65 .65]);
    h4 = uicontrol('style','popupmenu','units','norm','pos',[.25 .30 .5 .12],...
	'String','.ps|.eps','Value',1,'FontWeight','b','back',[.45 .65 .65]);
    h5 = uicontrol('style','popupmenu','units','norm','pos',[.25 .15 .5 .12],...
	'String','standard|Level 2','Value',1,'FontWeight','b','back',[.45 .65 .65]);
    h6 = uicontrol('style','pushbutton','units','norm','pos',[.20 0.02 .25 .10],...
	'String','print','FontWeight','b','back',[0 .8 0],'Callback','cflag=8;callback');
    h7 = uicontrol('style','pushbutton','units','norm','pos',[.55 0.02 .25 .10],...
	'String','cancel','FontWeight','b','back',[.8 0 0],'Callback',...
	'close;clear h1 h2 h3 h4 h5 h6 h7 pstring1 pstring0 filename');
  % print jpg file
  elseif otype == 2
    figure('units','norm','pos',[0.05 .5 .25 .4],'Name','browser JPEG output screen')
    uicontrol('Style','Text','String','filename:','FontWeight','b',...
	'FontSize',10,'pos',[.1 .85 .8 .05],'units','norm','FontUnits','norm',...
	'back',get(gcf,'Color'),'fore',[.2 .2 .2]);
    h1=uicontrol('Style','edit','pos',[.1 .75 .8 .1],'FontSize',14,...
	'units','norm','String','file.jpg','back',[.85 .9 .85],'fore',[.2 .2 .2]);
    uicontrol('Style','Text','String','quality level:','FontWeight','b',...
	'FontSize',10,'pos',[.2 .62 .6 .05],'units','norm','FontUnits','norm',...
	'back',get(gcf,'Color'),'fore',[.2 .2 .2]);    
    h2 = editnum(gcf,1,100,.1, 'INT_SL_B', 'units','norm',...
	'pos',[.2 .50 .6 .12], 'back',[.85 .9 .85]);
    set(h2,'Value',75,'String','75')
    h3 = uicontrol('style','popupmenu','units','norm','pos',[.25 .30 .5 .12],...
	'String','landscape|portrait|tall','Value',1,'FontWeight','b','back',[.45 .65 .65]);
    h4 = uicontrol('style','pushbutton','units','norm','pos',[.20 0.02 .25 .10],...
	'String','print','FontWeight','b','back',[0 .8 0],'Callback','cflag=9;callback');
    h5 = uicontrol('style','pushbutton','units','norm','pos',[.55 0.02 .25 .10],...
	'String','cancel','FontWeight','b','back',[.8 0 0],'Callback',...
	'close;clear h1 h2 h3 h4 h5 pstring1 pstring0 filename');  

  elseif otype == 3
    % save x variable
    xv = get(xaxis,'value');x=names{xv};
    disp(['    saving x-axis variable: data.' x ' to ' x '.asc']);
    eval([x ' = data.' x ';save ' x '.asc ' x ' -ascii -double;clear ' x])
    % save y variables
    yv = get(yaxis,'value');
    for i = 1:length(yv)
      y = names{yv(i)};
      disp(['    saving y-axis variable: data.' y ' to ' y '.asc']);
      eval([y ' = data.' y ';save ' y '.asc ' y ' -ascii -double;clear ' y])
    end

  elseif otype == 4
    % save x variable
    xv = get(xaxis,'value');x=names{xv};
    disp(['    saving x-axis variable: data.' x ' to ' x '.mat']);
    eval([x ' = data.' x ';save ' x '.mat ' x ' ;clear ' x])
    % save y variables
    yv = get(yaxis,'value');
    for i = 1:length(yv)
      y = names{yv(i)};
      disp(['    saving y-axis variable: data.' y ' to ' y '.mat']);
      eval([y ' = data.' y ';save ' y '.mat ' y ' ;clear ' y])
    end

  elseif otype == 5
    %print out x variable
    xv = get(xaxis,'value');x=names{xv};
    disp(['x-axis variable: data.' x ' : ']);eval(['data.' x])
    disp(' ');disp('Hit any key to continue');pause;disp(' ')
    % print out y variables
    yv = get(yaxis,'value');
    for i = 1:length(yv)
      y=names{yv(i)};
      disp(['y-axis variable: data.' y ' : ']);eval(['data.' y])
      if i ~= length(yv);
	disp(' ');disp('Hit any key to continue');pause
      end
    end
  end  % on otype

% change the number of subplots
elseif cflag == 7
  % quit blowup and delte all axes with tag == screen1 
  blowup(4)
  delete(findobj('Type','axes','Parent',gcf));
  % get number of desired subplots from gui
  nplots = get(npb,'Value');
  % set up plots. only does 1-4 currently
  if nplots == 1
    set(gca,'Position',[.13 .33 .775 .57],'units','norm')
  elseif nplots == 2
    subplot(211);set(gca,'Position',[.13 .67 .775 .28],'units','norm')
    subplot(212);set(gca,'Position',[.13 .33 .775 .28],'units','norm')
  elseif nplots == 3
    subplot(311);set(gca,'Position',[.13 .77 .775 .18],'units','norm')
    subplot(312);set(gca,'Position',[.13 .55 .775 .18],'units','norm')
    subplot(313);set(gca,'Position',[.13 .33 .775 .18],'units','norm')
  elseif nplots == 4
    subplot(411);set(gca,'Position',[.13 .84 .775 .13],'units','norm')
    subplot(412);set(gca,'Position',[.13 .67 .775 .13],'units','norm')
    subplot(413);set(gca,'Position',[.13 .50 .775 .13],'units','norm')
    subplot(414);set(gca,'Position',[.13 .33 .775 .13],'units','norm')
  end
  % restart blowup
  blowup

% pull up PS print box
elseif cflag == 8
  filename = get(h1,'String');
  if get(h4,'Value') == 1 
    pstring1 = '-dps';
  else
    pstring1 = '-deps';
  end
  if get(h2,'Value') == 1
    pstring1 = [pstring1 'c'];
  end
  if get(h5,'Value') == 2
    pstring1 = [pstring1 '2'];
  end
  if get(h3,'Value') == 1
    pstring0 = ' orient landscape; ';
  elseif get(h3,'Value') == 2
    pstring0 = 'orient portrait; ';
  else
    pstring0 = 'orient tall; ';
  end
  close
  eval([pstring0 'print ' pstring1 ' ' filename])
  clear h1 h2 h3 h4 h5 h6 h7 pstring1 pstring0
  
% pull up JPEG print box
elseif cflag == 9
  filename = get(h1,'String');
  pstring1 = '-djpeg';
  pstring1 = [pstring1 get(h2,'String')];
  if get(h3,'Value') == 1
    pstring0 = ' orient landscape; ';
  elseif get(h3,'Value') == 2
    pstring0 = 'orient portrait; ';
  else
    pstring0 = 'orient tall; ';
  end
  close
  eval([pstring0 'print ' pstring1 ' ' filename])
  clear h1 h2 h3 h4 h5 pstring1 pstring0 filename


%
% callbacks for spectrum screen
%
  
% update screen 2
elseif cflag == 10
  index = get(sc2,'Value');
  coi=index-length(co)*fix(index/length(co))+1;

  % if radiances already read in
  if isfield(data,'Radiance');
    radiance = data.Radiance(index,:);
  else
    % if in random read mode, read this (entire) spectrum from the file
    radiance = fnetcdf{data.Rname}(index,:);
  end
  cflag = 10.5;sflag = 1;callback
  
elseif cflag == 10.5

  if strcmp(get(gca,'NextPlot'),'add')
    nlabels = nlabels + 1;
    
    if sflag == 1
      labels(nlabels) = text(0,0,...
	[datestr(data.dateNumber(index),13) ',' num2str(data.sceneMirrorAngle(index)) '^o']);
      set(labels(nlabels),'Color',co(coi,:),'FontWeight','b','FontSize',12,'Units','norm',...
	'Position',[-0.12 0.97-nlabels*0.03 0])
    elseif sflag == 2
      labels(nlabels) = text(0,0,...
	[num2str(begintime) '-' num2str(endtime) ',sma=' num2str(sma) ' avg']);
      set(labels(nlabels),'Color',co(coi,:),'FontWeight','b','FontSize',12,'Units','norm',...
	'Position',[-0.12 0.97-nlabels*0.03 0])
    end
  else
    if exist('labels') & ~isempty(intersect(findobj,labels))
      delete(labels);clear labels;nlabels = 0;
    end
  end

  ax = axis;
  tmp = get(RadOrBT1,'String');
  if exist('apod_flag') & apod_flag == 1
    [vout,rout] = apodize(data.wnum1,radiance,MOPDout);
  else
    vout = data.wnum1;
    rout = reshape(radiance,length(radiance),1);
  end

  if tmp(1) == 'R'
    h=plot(vout,rout,'Color',co(coi,:));
  else
    h=plot(vout,rad2bt(vout,rout),'Color',co(coi,:));
  end
  set(h,'Tag','specplot')
  set(gca,'Position',[.09 .20 .775 .70],'units','norm','FontWeight','b','Tag','specaxis')
  axis(ax)
  grid on;xlabel('wavenumber');

  if sflag == 1
    title([datestr(dn(data.time_offset(index)+data.base_time),0) ...
      '. sceneMirrorAngle=' num2str(data.sceneMirrorAngle(index)) '^o. ' ...
      'lat,lon=' num2str(data.Latitude(index)) ',' num2str(data.Longitude(index)) ])
    set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
  elseif sflag == 2
    title([num2str(begintime) '-' num2str(endtime) ', sma = ' num2str(sma) ' average']);
    set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
  end

% increment record index by +1  
elseif cflag == 11
  index = get(sc2,'Value');
  index = min([data.nspec index+1]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 10;callback

% increment record index by -1  
elseif cflag == 12
  index = get(sc2,'Value');
  index = max([1 index-1]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 10;callback

% increment record index by + no_sma
elseif cflag == 15
  index = get(sc2,'Value');
  index = min([data.nspec index+no_sma]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 10;callback

% increment record index by - no_sma
elseif cflag == 16
  index = get(sc2,'Value');
  index = max([1 index-no_sma]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 10;callback
  
% plot radiances or BTs
elseif cflag == 13
  tmp = get(RadOrBT1,'String');
  if tmp(1) == 'R'
    set(RadOrBT1,'String','Brightness Temp');
  else
    set(RadOrBT1,'String','Radiance');
  end
  cflag = 10.5;callback
  
% clear figure
elseif cflag == 14
  delete(findobj(gca,'Type','line'));
  if exist('labels')
    delete(labels);clear labels;nlabels = 0;
  end
  title('')


  

% DHD, spectral radiance and optical properties
% update screen 2
elseif cflag == 20
  index = get(sc2,'Value');
  coi=index-length(co)*fix(index/length(co))+1;

  % if radiances already read in
  if isfield(data,'Radiance');
    radiance = data.Radiance(index,:);
  else
    % if in random read mode, read this (entire) spectrum from the file
    radiance = fnetcdf{data.Rname}(index,:);
  end

  OD_wn = OPRA.od(:,index);
  emis_wn = OPRA.emiss(:,index);
  emis_thin_wn = OPRA.emiss_thin(:,index);
  for i=1:size(OPRA.rad_avg,2)
    bt_avg(:,i) = bright_T(OPRA.wn_avg, OPRA.rad_avg(:,i));
  end

  % MiniBox parameters
  if index < 11
    v1 = 1;
  else
    v1 = index-10;
  end
  v2 = min(index+10,size(OPRA.time,2));

  if strcmp(get(gca,'NextPlot'),'add')
    subplot(H1)
    nlabels = nlabels + 1;
    labels(nlabels) = text(0,0,...
	[num2str(index), ',' ,datestr(data.dateNumber(index),13) ',' ...
	    num2str(data.sceneMirrorAngle(index)) '^o']);
    set(labels(nlabels),'Color',co(coi,:),'FontWeight','b','FontSize',12,'Units','norm',...
	'Position',[-0.18 0.97-nlabels*0.06 0])
  else
    if exist('labels')
      clear labels;nlabels = 0;
    end
  end

  subplot(H2)
  if ishold == 1
    subplot(H1), hold on;
  else
    subplot(H1), hold off;
  end
  
  tmp = get(TimeOrSpec1,'String');
  if tmp(1) == 'S'

    % make buttons to turn on/off spectral microwindows in temporal mode
    if exist('mw') == 0
      for i=1:size(OPRA.wn_avg,1)
	colup = (OPRA.wn_avg(i) - min(OPRA.wn_avg))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
	coldn = (max(OPRA.wn_avg) - OPRA.wn_avg(i))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
	mw(i) = uicontrol('Style','CheckBox','back',[coldn 0 colup],...
	    'fore',[.9 .9 .9],'Position',[.005 (.94 - .04*i) .09 .04],'Value',1,...
	    'Units','norm','String',num2str(OPRA.wn_avg(i)),'Callback',...
	    'cflag=28;callback');
      end
      mwrst = uicontrol('Style','PushButton','Position',[.005 (.94 - .04*(i+1)) .09 .04],...
	  'Units','norm','String','Reset','Callback','cflag=28.1;callback');
      test = zeros(size(OPRA.wn_avg,1),1);
    end

    if exist('CldBou') == 0
      delete(Window); clear Window
      delete(RadOrBT1); clear RadOrBT1
      CldBou = uicontrol('Style','PushButton','Position',[.005 .07 .15 .04],'Value',1, ...
	  'units','norm','String','Radiance or T','Callback','cflag=23.7;callback');
      MiniBox = uicontrol('Style','CheckBox','Position',[.2 .07 .08 .04],'Value',0,...
	  'units','norm','String','Blowup','Callback','cflag=20;callback');
      cflag=23.8;callback
    elseif exist('RadOrBT1')
      cflag=23.9;callback
    else
      cflag=23.8;callback
    end

    cflag=23.95;callback

  else
    % remove buttons to turn on/off spectral microwindows in temporal mode
    if exist('mw')
      for i=1:size(OPRA.wn_avg,1)
	delete(findobj(gcf,'String',num2str(OPRA.wn_avg(i))));
	clear mw;
      end
    end

    if exist('mwrst') delete(findobj('String','Reset')); clear mwrst; end
    if exist('MiniBox') delete(MiniBox); clear MiniBox; end
    if exist('CldBou') delete(findobj(CldBou)); clear CldBou; end      
    
    if exist('RadOrBT1') == 0
      RadOrBT1 = uicontrol('Style','PushButton','units','norm','pos',[0.84 .89 .1 .05],...
	'Callback','cflag=23;callback','back',[0 .7 0],'String','Radiance',...
	'fore',[.2 .2 .2],'FontWeight','b');
    end

    if exist('Window') == 0
      Window = uicontrol('Style','CheckBox','Position',[.006 .92 .08 .04],'Value',1,...
	  'units','norm','String','Window','Callback','cflag=20.85;callback');
    end

    tmp = get(RadOrBT1,'String');
    if tmp(1) == 'B'
      subplot(H1),plot(data.wnum1,radiance,'Color',co(coi,:))
      if get(Window,'Value') == 1
	ax = axis;
	ax(1) = 750; ax(2) = 1200;
	set(gca,'Position',[.15 .6 .8 .35],'units','norm','FontWeight','b')
	axis(ax)
      else
	axis auto;
      end
      grid on;xlabel('wavenumber');ylabel('Radiance');
      title([datestr(dn(data.time_offset(index)+data.base_time),0) ...
	      '. sceneMirrorAngle=' num2str(data.sceneMirrorAngle(index)) '^o. ' ...
	      'lat,lon=' num2str(data.Latitude(index)) ',' num2str(data.Longitude(index)) ])
      set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
    else
      subplot(H1),plot(data.wnum1,rad2bt(data.wnum1',radiance),'Color',co(coi,:))
      if get(Window,'Value') == 1
	ax = axis;
	ax(1) = 750; ax(2) = 1200;
	set(gca,'Position',[.15 .6 .8 .35],'units','norm','FontWeight','b')
	axis(ax)
      else
	axis auto;
      end
      grid on;xlabel('wavenumber');ylabel('Brightness Temperature');
      title([datestr(dn(data.time_offset(index)+data.base_time),0) ...
	      '. sceneMirrorAngle=' num2str(data.sceneMirrorAngle(index)) '^o. ' ...
	      'lat,lon=' num2str(data.Latitude(index)) ',' num2str(data.Longitude(index)) ])
      set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
    end
    tmp = get(EmisOrOD1,'String');
    if tmp(1) == 'O'
      subplot(H2),plot(OPRA.wn_avg,emis_wn,'*',OPRA.wn_avg,emis_thin_wn,'o','Color',co(coi,:))
%      legend('Emis','Thin Emis',2)
      set(gca,'Position',[.15 .15 .8 .35],'units','norm','FontWeight','b')
      grid on;xlabel('wavenumber');ylabel('Emissivity');
      title(['Cld Base = ', num2str(OPRA.cld_base(index)), ' m; Cloud Top = ', ...
	  num2str(OPRA.cld_top(index)), ' m; Midcloud Temp = ', ...
	  num2str(OPRA.cld_temp(index)), ' ^oC'])
      set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
      axis([750, 1200, 0, 1])
    else
      subplot(H2),plot(OPRA.wn_avg,OD_wn,'*','Color',co(coi,:))
%      legend off;
      set(gca,'Position',[.15 .15 .8 .35],'units','norm','FontWeight','b')
      grid on;xlabel('wavenumber');ylabel('Optical Depth');
      title(['Cld Base = ', num2str(OPRA.cld_base(index)), ' m; Cloud Top = ', ...
	  num2str(OPRA.cld_top(index)), ' m; Midcloud Temp = ', ...
	  num2str(OPRA.cld_temp(index)), ' ^oC'])
      set(get(gca,'Title'),'Color',co(coi,:),'FontWeight','b','FontSize',14)
      ax = axis;
      if ax(4) < 3;
	axis([750 1200 0 3]);
      else
	axis([750 1200 0 5]);
      end
    end
    zoom on
  end

% Toggle full view and window view
elseif cflag == 20.85
  subplot(H1)
  if get(Window,'Value') == 1
    ax = axis;
    ax(1) = 750; ax(2) = 1200;
    set(gca,'Position',[.15 .6 .8 .35],'units','norm','FontWeight','b')
    axis(ax)
  else
    axis auto;
  end
  
% increment record index by +1  
elseif cflag == 21
  index = get(sc2,'Value');
  index = min([data.nspec index+1]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 20;callback

% increment record index by -1  
elseif cflag == 22
  index = get(sc2,'Value');
  index = max([1 index-1]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 20;callback

% choose radiances or BTs
elseif cflag == 23
  tmp = get(RadOrBT1,'String');
  if tmp(1) == 'R'
    set(RadOrBT1,'String','Brightness T');
  elseif tmp(1) == 'C'
    set(RadOrBT1,'String','Cloud Boundaries');
  else
    set(RadOrBT1,'String','Radiance');
  end
  cflag = 20;callback

% clear figure
elseif cflag == 23.5
  subplot(H1),delete(findobj(gca,'Type','line'));
  subplot(H2),delete(findobj(gca,'Type','line'));
  if exist('labels')
    delete(labels);clear labels;nlabels = 0;
  end

elseif cflag == 23.7
  tmp = get(CldBou,'String');
  if tmp(1) == 'C'
    set(CldBou,'String','Radiance or T');
    if exist('RadOrBT1') delete(RadOrBT1); clear RadOrBT1; end
    cflag = 23.8;callback
  else
    set(CldBou,'String','Cloud Boundaries');
    RadOrBT1 = uicontrol('Style','PushButton','units','norm','pos',[0.84 .89 .1 .05],...
	'Callback','cflag=23;callback','back',[0 .7 0],'String','Radiance',...
	'fore',[.2 .2 .2],'FontWeight','b');
    cflag = 23.9;callback
  end

% plot cloud boundaries
elseif cflag == 23.8
  if get(MiniBox,'Value') == 0
    subplot(H1),plot(OPRA.time,OPRA.cld_base/1000,'bo',OPRA.time,OPRA.cld_top/1000,'r+');
  else
    subplot(H1),plot(OPRA.time(v1:v2),OPRA.cld_base(v1:v2)/1000,...
	'bo',OPRA.time(v1:v2),OPRA.cld_top(v1:v2)/1000,'r+');
  end
  hold on,trak=axis; trakx=[OPRA.time(index); OPRA.time(index)]; traky=[trak(3); trak(4)];
  plot(trakx,traky,'k--');hold off;
  set(gca,'FontWeight','b');
  grid on;xlabel('Time');ylabel('Cloud Boundaries [km]');
  title([datestr(dn(data.time_offset(index)+data.base_time),0)])
    
% plot radiance or brightness temp in temporal mode
elseif cflag == 23.9
  subplot(H1),hold off;
  tmp = get(RadOrBT1,'String');
  for i=1:size(OPRA.wn_avg,1)
    colup = (OPRA.wn_avg(i) - min(OPRA.wn_avg))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
    coldn = (max(OPRA.wn_avg) - OPRA.wn_avg(i))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
    if test(i) == 0
      if (get(MiniBox,'Value')) == 0
	if tmp(1) == 'B'
	  pl_top(i) = plot(OPRA.time,OPRA.rad_avg(i,:),'Color',[coldn 0 colup]);
	else
	  pl_top(i) = plot(OPRA.time,bt_avg(i,:),'Color',[coldn 0 colup]);
	end
      else
	if tmp(1) == 'B'
	  pl_top(i) = plot(OPRA.time(v1:v2),OPRA.rad_avg(i,v1:v2),'Color',[coldn 0 colup]);
	else
	  pl_top(i) = plot(OPRA.time(v1:v2),bt_avg(i,v1:v2),'Color',[coldn 0 colup]);
	end
      end
      hold on;
    end
  end
  trak=axis; trakx=[OPRA.time(index); OPRA.time(index)]; traky=[trak(3); trak(4)];
  plot(trakx,traky,'k--')
  hold off;
  set(gca,'FontWeight','b')
  if tmp(1) == 'B'
    grid on;xlabel('Time');ylabel('Radiance')
  else
    grid on;xlabel('Time');ylabel('Brightness Temperature')
  end
  title([datestr(dn(data.time_offset(index)+data.base_time),0)])

% plot emissivity or OD in temporal mode
elseif cflag == 23.95
  subplot(H2),hold off;
  tmp = get(EmisOrOD1,'String');
  for i=1:size(OPRA.wn_avg,1)
    colup = (OPRA.wn_avg(i) - min(OPRA.wn_avg))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
    coldn = (max(OPRA.wn_avg) - OPRA.wn_avg(i))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
    if test(i) == 0
      if get(MiniBox,'Value') == 0
	if tmp(1) == 'O'
	  pl_bot(i) = plot(OPRA.time,OPRA.emiss(i,:),'Color',[coldn 0 colup]);
	else
	  pl_bot(i) = plot(OPRA.time,OPRA.od(i,:),'Color',[coldn 0 colup]);
	end
      else
	if tmp(1) == 'O'
	  pl_bot(i) = plot(OPRA.time(v1:v2),OPRA.emiss(i,v1:v2),'Color',[coldn 0 colup]);
	else
	  pl_bot(i) = plot(OPRA.time(v1:v2),OPRA.od(i,v1:v2),'Color',[coldn 0 colup]);
	end
      end
      hold on;
    end
  end
  set(gca,'FontWeight','b')
  if tmp(1) == 'O'
    grid on;xlabel('Time');ylabel('Emissivity')
  else
    ax = axis;
    if ax(4) > 10
      axis([ax(1) ax(2) ax(3) 10]);
    else
      axis auto
    end
    grid on;xlabel('Time');ylabel('Optical Depth')
  end
  trak=axis; trakx=[OPRA.time(index); OPRA.time(index)]; traky=[trak(3); trak(4)];
  plot(trakx,traky,'k--')
  hold off;  
    
% choose emissivity or OD
elseif cflag == 24
  tmp = get(EmisOrOD1,'String');
  if tmp(1) == 'E'
    set(EmisOrOD1,'String','Optical Depth');
  else
    set(EmisOrOD1,'String','Emissivity');
  end
  cflag = 20;callback
 
% increment record index by +13  
elseif cflag == 25
  index = get(sc2,'Value');
  index = min([data.nspec index+13]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 20;callback

% increment record index by -13  
elseif cflag == 26
  index = get(sc2,'Value');
  index = max([1 index-13]);
  set(sc2,'Value',index,'String',num2str(index));
  cflag = 20;callback

% remove/add temporal data for individual spectral microwindows
elseif cflag == 28
  for i=1:size(OPRA.wn_avg,1)
    tmp = get(mw(i),'value');
    if ( (tmp == 0) & (test(i) == 0) )
      set(mw(i),'back',[.9 .9 .9],'fore',[.1 .1 .1])
      if exist('RadOrBT1') delete(pl_top(i)); end
      delete(pl_bot(i))
      test(i) = 1;
    elseif ( (tmp == 1) & (test(i) == 1) )
      colup = (OPRA.wn_avg(i) - min(OPRA.wn_avg))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
      coldn = (max(OPRA.wn_avg) - OPRA.wn_avg(i))/(max(OPRA.wn_avg) - min(OPRA.wn_avg));
      set(mw(i),'back',[coldn 0 colup],'fore',[.9 .9 .9]);
      if exist('RadOrBT1')
	tmp = get(RadOrBT1,'String');
	if (tmp(1) == 'B') & (get(MiniBox,'Value') == 1)
	  subplot(H1),hold on;pl_top(i) = ...
	      plot(OPRA.time(v1:v2),OPRA.rad_avg(i,v1:v2),'Color',[coldn 0 colup]);hold off;
	elseif (tmp(1) == 'R') & (get(MiniBox,'Value') == 1)
	  subplot(H1),hold on;pl_top(i) = ...
	      plot(OPRA.time(v1:v2),bt_avg(:,v1:v2),'Color',[coldn 0 colup]);hold off;
	elseif (tmp(1) == 'B') & (get(MiniBox,'Value') == 0)
	  subplot(H1),hold on;pl_top(i) = ...
	      plot(OPRA.time,OPRA.rad_avg(i,:),'Color',[coldn 0 colup]);hold off;
	else
	  subplot(H1),hold on;pl_top(i) = ...
	      plot(OPRA.time,bt_avg(i,:),'Color',[coldn 0 colup]);hold off;
	end
      end
      tmp = get(EmisOrOD1,'String');
      if (tmp(1) == 'O') & (get(MiniBox,'Value') == 1)
	  subplot(H2),hold on;pl_bot(i) = ...
	    plot(OPRA.time(v1:v2),OPRA.emiss(i,v1:v2),'Color',[coldn 0 colup]);hold off;
      elseif (tmp(1) == 'E') & (get(MiniBox,'Value') == 1)
	subplot(H2),hold on;pl_bot(i) = ...
	    plot(OPRA.time(v1:v2),OPRA.od(i,v1:v2),'Color',[coldn 0 colup]);hold off;
      elseif (tmp(1) == 'O') & (get(MiniBox,'Value') == 0)
	subplot(H2),hold on;pl_bot(i) = ...
	    plot(OPRA.time,OPRA.emiss(i,:),'Color',[coldn 0 colup]);hold off;
      else
	subplot(H2),hold on;pl_bot(i) = ...
	    plot(OPRA.time,OPRA.od(i,:),'Color',[coldn 0 colup]);hold off;
      end
      test(i) = 0;
    end
  end

% reset microwindow buttons
elseif cflag == 28.1
  clear mw;
  cflag=20;callback

% toggle between spectral and temporal data
elseif cflag == 29
  tmp = get(TimeOrSpec1,'String');
  if tmp(1) == 'T'
    set(TimeOrSpec1,'String','Spectral');
  else
    set(TimeOrSpec1,'String','Temporal');
  end
  cflag = 20;callback  

  
%
% calls 40 to 49 are for the mapping screen
%

% set colormap limits
elseif cflag == 40

  if exist('mn')
    % do manual or auto colorbar scaling ?
    if get(cmap_mode,'Value')==1
      % autoscale
      min_mn = min(mn);max_mn = max(mn);
    elseif get(cmap_mode,'Value')==2
      % manual
      % if manual min or max is empty, autoscale that limit
      min_mn = str2num(get(cbar_min,'String'));
      if isempty(min_mn);min_mn=min(mn);end
      max_mn = str2num(get(cbar_max,'String'));
      if isempty(max_mn);max_mn=max(mn);end
    end

    % update displayed colormap limits
    set(cbar_min,'String',num2str(min_mn))
    set(cbar_max,'String',num2str(max_mn))
  else
    disp('can''t adjust colormap - no mapping data defined yet')
  end
  
% map a housekeeping data
elseif cflag == 41
  var = names{get(varlist,'Value')};
  eval(['mn = data.' var ';'])
  set(gcf,'CurrentAxes',mapaxis);hold on;title(var)
  set(gcf,'CurrentAxes',timeaxis);hold on;ylabel(var)
  title('time sereis of nadir views')
  cflag = 43;callback
  
% add spectral data to figure 3
elseif cflag == 42

  wn1a = str2num(get(wnbr1a,'String'));
  wn2a = str2num(get(wnbr2a,'String'));
  wninda = find(data.wnum1 >= wn1a & data.wnum1 <= wn2a);
  tmp = get(RadOrBT2,'Value');
  if tmp == 3 | tmp == 4
    wn1b = str2num(get(wnbr1b,'String'));
    wn2b = str2num(get(wnbr2b,'String'));
    wnindb = find(data.wnum1 >= wn1b & data.wnum1 <= wn2b);
  end

  % get indices of times to load in and map
  time1 = datenum(get(time1b,'String'));
  time2 = datenum(get(time2b,'String'));
  indtime = find(dn(data.nss1970) >= time1 & dn(data.nss1970) <= time2);

  % if radiances already read in
  if isfield(data,'Radiance');
    radiancea = data.Radiance(indtime,wninda);
    if tmp == 3 | tmp == 4
      radianceb = data.Radiance(indtime,wnindb);
    end
  else
    % if in random read mode, read the desired portion of each spectrum from the file
    radiancea = fnetcdf{data.Rname}(indtime,wninda);
    if tmp == 3 | tmp == 4
      radianceb = fnetcdf{data.Rname}(indtime,wnindb);
    end
  end
    
  if tmp == 1 | tmp == 3
    % radiances
    if tmp == 1
      mn = mean(radiancea')';
    elseif tmp == 3
      mn = mean(radiancea')' - mean(radianceb')';
    end
    set(gcf,'CurrentAxes',mapaxis)
    hold on
    if tmp == 1
      set(get(gca,'Title'),'String',...
	[num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average Radiance'])
      set(get(gca,'YLabel'),'String',...
	[num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average Radiance'])
    elseif tmp == 3
      set(get(gca,'Title'),'String',...
	  [num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average Radiance minus ' ...
          num2str(wn1b) '-' num2str(wn2b) ' cm^{-1} average Radiance'])
      set(get(gca,'YLabel'),'String',...
	  [num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average Radiance minus ' ...
           num2str(wn1b) '-' num2str(wn2b) ' cm^{-1} average Radiance'])
    end
  elseif tmp == 2 | tmp == 4
    rad_num = size(radiancea);
    mn = zeros(rad_num(1,1),1);
    for (i=1:rad_num(1,1))
      if tmp == 2
        mn(i) = mean(rad2bt(data.wnum1(wninda),radiancea(i,:)'));
      elseif tmp == 4
        mn(i) = mean(rad2bt(data.wnum1(wninda),radiancea(i,:)')) - ...
	        mean(rad2bt(data.wnum1(wnindb),radianceb(i,:)'));
      end
    end
    set(gcf,'CurrentAxes',mapaxis)
    hold on
    if tmp == 2
      set(get(gca,'Title'),'String',...
	[num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average T_B'])
      set(get(gca,'YLabel'),'String',...
	[num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average T_B'])
    elseif tmp == 4
      set(get(gca,'Title'),'String',...
	  [num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average T_B minus ' ...
           num2str(wn1b) '-' num2str(wn2b) ' cm^{-1} average T_B'])
      set(get(gca,'YLabel'),'String',...
	  [num2str(wn1a) '-' num2str(wn2a) ' cm^{-1} average T_B minus ' ...
           num2str(wn1b) '-' num2str(wn2b) ' cm^{-1} average T_B'])
    end
  end
  cflag = 43;callback

  
elseif cflag == 43
%  if length(mn) == data.nspec;
  if length(mn) == length(indtime)

    % get colormap scaling mode and min, max values
    cflag = 40;callback
    
    mn_scaled = (mn-min_mn)/(max_mn-min_mn);
    mn_scaled = mn_scaled * (length(cmap)-1)+1;
    
    set(cbar,'XTick',[],'XTickLabel',[]);

    set(gcf,'CurrentAxes',mapaxis)
    if ~get(findobj('Tag','mapholdon'),'Value')
      delete(findobj(gca,'Tag','mapdata'))
    end

    % plot the data on a lat/lon grid
    mapdata=[];
    for i = 1:length(mn_scaled)
      mapdata(i)=plot(data.Longitude(indtime(i)),data.Latitude(indtime(i)),'or',...
	  'MarkerSize',7,'Tag','mapdata');

      % if the data point value is outside the colormap limits, set that
      % marker color to grey.  Otherwise, map the value into the colormap.
      if mn_scaled(i) < 1 | mn_scaled(i) > length(cmap)
	set(mapdata(i),'Color',[.7 .7 .7])
      else
	set(mapdata(i),'MarkerFaceColor',cmap(fix(mn_scaled(i)),:),...
	               'MarkerEdgeColor',cmap(fix(mn_scaled(i)),:));
      end
    end

    set(gcf,'CurrentAxes',timeaxis)
    if ~get(findobj('Tag','mapholdon'),'Value')
      delete(timedata)
    end
    ind00p = find(dn(data.nss1970) >= time1 & dn(data.nss1970) <= time2 & ...
                data.sceneMirrorAngle==0);
    timedata=plot(data.timeDECIMAL(ind00p),mn(ind00p),'d-','MarkerSize',4);
    set(get(gca,'Title'),'String','time sereis of nadir views')
    xlabel('decimal hours')
    grid on;axis auto

  else
    disp('map data has wrong dimensions')
  end 

elseif cflag == 47
   delete(findobj(gcf,'Tag','wnbrs'))
      wnbr1a = uicontrol('Style','edit','String',num2str(min(data.wnum1)),'pos',[0.02 .52 .08 .04],...
      'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
   uicontrol('Style','Text','String','v1','FontWeight','b',...
      'FontSize',10,'pos',[.02 .56 .08 .02],'units','norm','FontUnits','norm',...
      'back',get(gcf,'Color')*.9,'Tag','wnbrs');
   wnbr2a = uicontrol('Style','edit','String',num2str(max(data.wnum1)),'pos',[0.11 .52 .08 .04],...
      'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
   uicontrol('Style','Text','String','v2','FontWeight','b',...
      'FontSize',10,'pos',[.11 .56 .08 .02],'units','norm','FontUnits','norm',...
      'back',get(gcf,'Color')*.9,'Tag','wnbrs');
   tmp = get(RadOrBT2,'Value');
   if tmp == 3 | tmp == 4
     wnbr1b = uicontrol('Style','edit','String',num2str(min(data.wnum1)),'pos',[0.02 .475 .08 .04],...
      'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
     wnbr2b = uicontrol('Style','edit','String',num2str(max(data.wnum1)),'pos',[0.11 .475 .08 .04],...
      'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
   end
     
elseif cflag == 48
  set(gcf,'CurrentAxes',mapaxis);hold on
  delete(findobj(gca,'Tag','mapdata'))
  delete(findobj(gca,'Tag','pb_9'))
  plot(data.Longitude(ind00),data.Latitude(ind00),'o-',...
    'Color','r','LineWidth',2,'MarkerSize',3,'Tag','mapdata');
  plot(data.Longitude(indm45),data.Latitude(indm45),'o-',...
    'Color','b','LineWidth',2,'MarkerSize',3,'Tag','mapdata');
  plot(data.Longitude(indp45),data.Latitude(indp45),'o-',...
    'Color','b','LineWidth',2,'MarkerSize',3,'Tag','mapdata');

  set(gcf,'CurrentAxes',timeaxis)
  delete(timedata);
  timedata = plot(data.timeDECIMAL(ind00),NaN*ones(length(ind00),1),'d-','MarkerSize',4);
  title('time sereis of nadir views')
  xlabel('decimal time');ylabel('')
  grid on;axis auto

elseif cflag == 48.5
  if exist('mn_scaled')==1
   figure
   sma = unique(data.sceneMirrorAngle);
%   ind = find(mn_scaled < 1 | mn_scaled > length(cmap));
   img_data = reshape(mn_scaled,length(sma),length(mn_scaled)/length(sma))';
%   img_data(ind) = img_data(ind)*NaN;
   pcolor(sma,data.timeDECIMAL(ind00),img_data);
   shading interp
   set(gcf,'Color','k','Units','norm','Position',[.78 .05 .2 .85])
   xlabel('scene mirror angle')
   ylabel('decimal time')
   set(gca,'XColor','w','YColor','w','Position',[.17 .1 .75 .85])  
   colorbar('horiz')
   h=text(.1,.05,num2str(min(mn)));set(h,'Color','w','Units','norm','Position',[0 -0.25],'Hor','left')
   h=text(.8,.05,num2str(max(mn)));set(h,'Color','w','Units','norm','Position',[1 -0.25],'Hor','right')
   zoom on
   drawnow
 else
   disp('no data to display')
  end 
  
  
elseif cflag == 49
  clf
  close
  clear maphandle mapbutton1 mapbutton2 varlist wnbr1 wnbr2 mn mn_scaled

elseif cflag == 49.5
  % change map resolution
  smapres = get(mapresbutton,'Value');
  % check to see if selected resolution is already in place
  if imapres == smapres
     % do nothing
  else
     if smapres==1;res='l';elseif smapres==2;res='i';elseif smapres==3;res='h';end
     % change resolution
     % delete current map
     delete(findobj('Tag','cstplot'))
     ax = axis;
     plot_cst(ax(1:2),ax(3:4),res,2,quirkflag);
     imapres=smapres;
  end

% map probe
elseif cflag == 50
  if ~isempty(findstr(get(pbutton,'String'),'Off'))
    set(pbutton,'String','Probe On');
    zoom off
    pb_1=uicontrol('Style','text','units','norm','Position',[.015 .91 .20 .02],...
      'HorizontalAlignment','left');
    pb_2=uicontrol('Style','text','units','norm','Position',[.015 .87 .20 .02],...
      'HorizontalAlignment','left');
    pb_3=uicontrol('Style','text','units','norm','Position',[.015 .85 .20 .02],...
      'HorizontalAlignment','left');
    pb_4=uicontrol('Style','text','units','norm','Position',[.015 .83 .20 .02],...
      'HorizontalAlignment','left');
    pb_5=uicontrol('Style','text','units','norm','Position',[.015 .81 .20 .02],...
      'HorizontalAlignment','left');
    pb_6=uicontrol('Style','text','units','norm','Position',[.015 .79 .20 .02],...
      'HorizontalAlignment','left');
    pb_7=uicontrol('Style','text','units','norm','Position',[.015 .77 .20 .02],...
      'HorizontalAlignment','left');
    set(gcf,'Pointer','crossh','WindowButtonMotionFcn','cflag=51;callback',...
	'WindowButtonDownFcn','cflag=52;callback');
  else
    set(pbutton,'String','Probe Off');
    set(gcf,'WindowButtonMotionFcn','','WindowButtonDownFcn','','Pointer','Arrow');
    zoom on
    delete([pb_1 pb_2 pb_3 pb_4 pb_5 pb_6 pb_7])
    delete(findobj(gca,'Tag','pb_9'))
  end

elseif cflag == 51
  cp=get(gca,'CurrentPoint');cp=cp(1,2:-1:1);  % get current mouse position
  ax=axis;
  if cp(2) >= ax(1) & cp(2) <= ax(2) & cp(1) >= ax(3) & cp(1) <= ax(4) 
    set(pb_1,'String',sprintf('Lat,Lon = [%7.3f,%7.3f]',cp))  
  else
    set(pb_1,'String','Lat,Lon = [  ,  ]')  
  end

elseif cflag == 52
  cp=get(gca,'CurrentPoint');cp=cp(1,2:-1:1);
  ax=axis;
  ind1=find(abs(data.Latitude-cp(1))<=.1 & abs(data.Longitude-cp(2))<=.1);
  if length(ind1) >= 1
    dist = zeros(length(ind1),1);
    for i = 1:length(ind1)
      dist(i)=sqrt((cp(1)-data.Latitude(ind1(i)))^2 + (cp(2)-data.Longitude(ind1(i)))^2);
    end
    ind=find(abs(dist)==min(abs(dist)));ind=ind1(ind(1));
    if cp(2) >= ax(1) & cp(2) <= ax(2) & cp(1) >= ax(3) & cp(1) <= ax(4) & length(ind)==1
      hold on
      plot(data.Longitude(ind),data.Latitude(ind),'ok','MarkerSize',10,'Tag','pb_9')
      hold off
      % add plot to spectral screen
      h1 = findobj(0,'Tag','specplot');
      if ~isempty(h1)
        set(0,'CurrentFigure',findobj(0,'Tag','specfigure'))
        index = ind;
        coi=index-length(co)*fix(index/length(co))+1;
        if isfield(data,'Radiance');
          radiance = data.Radiance(index,:);
        else
          radiance = fnetcdf{data.Rname}(index,:);
        end
        cflag = 10.5;sflag = 1;callback
        set(0,'CurrentFigure',findobj(0,'Tag','mapfigure'))
      end
      set(pb_1,'String',sprintf('current Lat,Lon = [ %6.3f,%6.3f]',cp))
      set(pb_2,'String',sprintf('selected : index # %4i',data.index(ind)))
      set(pb_3,'String',['  time : ' datestr(data.dateNumber(ind),0)])
      set(pb_4,'String',sprintf('  Lat,Lon : [ %6.3f,%6.3f]',[data.Latitude(ind) data.Longitude(ind)]))
      set(pb_5,'String',sprintf('  altitude : %7.3f km',data.Altitude(ind)*12*2.54/1e5))
      set(pb_6,'String',sprintf('  sceneMirrorAngle : %4.2f',data.sceneMirrorAngle(ind)))
      if exist('mn')
        set(pb_7,'String',sprintf('  map value = %10.3f',mn(ind)))
      end
    else
      set(pb_1,'String','current Lat,Lon = [  ,  ]')
    end
  end

% quit screen 2
elseif cflag == 98
  clf
  close

% quit screen 1
elseif cflag == 99
  clf
  close

elseif cflag == 110
  h = findobj('Tag','averager');
  % create averaging window
  figure(5)
  avg_window = gcf;
  clf
  set(gcf,'Units','Norm','Position',[.33 .45 .37 .37])
  uicontrol('Units','norm','Position',[.1 .9 .8 .07],'Style','Text',...
      'String','Averaging Window','FontSize',18,...
      'back',get(gcf,'color'),'fore','b');
  uicontrol('Units','norm','Position',[.1 .6 .8 .3],'Style','Text',...
      'back',get(gcf,'color'),'fore','b','Hor','left','String',...
      ['Enter the begin and end times in HHMMSS and scene mirror angle ',...
       'in degrees.  Enter "*" if all angles are desired.  Then press the ',...
       'red "Average" button to produce an ascii ',...
       'text file of the mean and standard deviation radiances ',...
       '(default is "average.asc") and to ',...
       'plot the radiances in this window.  Press the gray "Close" button to ',...
       'abort.  Once the mean radiance has been plotted, use the blue ',...
       'blowup buttons to change the axes limits, press the "Add to ',...
       'Spectral Screen" to plot the radiances in the main spectral screen ',...
       ', and/or press the "Close Window" button to abort.']);
  uicontrol('Units','norm','Position',[.1 .5 .4 .07],'Style','Text',...
      'String',['begin time'],'FontSize',18,...
      'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.1 .41 .4 .07],'Style','Text',...
      'String',['(HHMMSS)'],'FontSize',14,'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.5 .5 .4 .07],'Style','Text',...
      'String','end time','FontSize',18,'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.5 .41 .4 .07],'Style','Text',...
      'String',['(HHMMSS)'],'FontSize',14,'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.15 .34 .3 .07],'Style','Edit',...
      'FontSize',14,'FontWeight','b','back',get(gcf,'color')*.9,'fore','r',...
      'Tag','begintime');
  uicontrol('Units','norm','Position',[.55 .34 .3 .07],'Style','Edit',...
      'FontSize',14,'FontWeight','b','back',get(gcf,'color')*.9,'fore','r',...
      'Tag','endtime');
  uicontrol('Units','norm','Position',[.10 .24 .45 .07],'Style','Text',...
      'String','scene mirror angle:','FontSize',18,'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.55 .24 .2 .07],'Style','Edit',...
      'FontSize',14,'FontWeight','b','back',get(gcf,'color')*.9,'fore','r',...
      'Tag','sma','String','0');
  uicontrol('Units','norm','Position',[.10 .14 .45 .07],'Style','Text',...
      'String','output filename:','FontSize',18,'back',get(gcf,'color'));
  uicontrol('Units','norm','Position',[.55 .14 .3 .07],'Style','Edit',...
      'FontSize',14,'FontWeight','b','back',get(gcf,'color')*.9,'fore','r',...
      'Tag','ofn','String','average.asc');
  uicontrol('Units','norm','Position',[.1 .0 .35 .10],'Style','Pushbutton',...
      'String','Average','FontSize',18,'back','r','fore','k','Callback',...
      'cflag=112;callback');  
  uicontrol('Units','norm','Position',[.55 .0 .35 .10],'Style','Pushbutton',...
      'String','Close','FontSize',18,'back',get(gcf,'color')*.9,'fore','k','Callback',...
      'close(avg_window)');  
  
elseif cflag == 111
  h = findobj('Tag','resolution2');
  mopd = get(h,'String');
  if ~isempty(findstr(mopd,'def'))
    disp('full spectral resolution')
    set(h,'String',['def (' num2str(1/(2*mean(diff(data.wnum1)))) ')'])
    apod_flag = 0;
  else
    MOPDout = str2num(mopd);
    apod_flag = 1;
  end
  cflag = 10.5;callback

elseif cflag == 112
  % call back for averaging window
  figure(avg_window)
  begintime = str2num(get(findobj('Tag','begintime'),'String'));
  endtime = str2num(get(findobj('Tag','endtime'),'String'));
  sma = get(findobj('Tag','sma'),'String');
  ofn = get(findobj('Tag','ofn'),'String');
  if ~isempty(findstr(sma,'*'))
    sma = unique(data.sceneMirrorAngle);
  else
    sma = str2num(sma);
  end
  if isempty(begintime) | isempty(endtime) | isempty(sma)
    errordlg(['must specify begin time, end time, and scene mirror angle' ...
       ' in order to select records for averaging.  Use * for all angles.  try again.'])
  else
    if length(sma) == 1
      ind=find(data.timeHHMMSS >= begintime & data.timeHHMMSS <= endtime & ...
	data.sceneMirrorAngle==sma);
    else
      ind=find(data.timeHHMMSS >= begintime & data.timeHHMMSS <= endtime);
    end

    if length(ind) > 1
      % read in these radiances
      if isfield(data,'Radiance');
        rads = data.Radiance(ind,:);        % if radiances already read in
      else
        rads = fnetcdf{data.Rname}(ind,:);      % if in random read mode
      end
      mean_rad = mean(rads);
      std_rad = std(rads);
      clf
      s = size(rads);
      subplot(211);plot(data.wnum1,mean_rad)
      title([num2str(begintime) ' - ' num2str(endtime) '. ' num2str(s(1)) ' spectra selected: mean radiance'])
      subplot(212);plot(data.wnum1,std_rad)
      title('std of  radiances')
      blowup
      mmm = [data.wnum1 mean_rad' std_rad'];

      if length(ofn) == 0
        ofn = 'average.asc';
      end
      eval(['save ' ofn ' -ascii mmm'])
      disp(['mean and standard deviation radiances saved to "' ofn '".'])
      uicontrol('Style','Pushbutton','String','Add to Spectral Screen',...
	  'Units','norm','Position',[0 0 .3 .05],...
	  'Callback','cflag=113;callback');
      uicontrol('Style','Pushbutton','String','Close Window',...
	  'Units','norm','Position',[.31 0 .2 .05],...
	  'Callback','close(avg_window)');
    else
      errordlg('not enough records found. try again')
    end

  end

% add averaged spectrum to spectral screen
elseif cflag == 113

  figure(spectra_screen)
  if exist('coi')
    coi = min([coi+1 length(co)]);
  else
    coi = 1;
  end
  
  radiance = mean_rad;
  cflag = 10.5;sflag = 2;callback
  
end
