
% create spectrum screen 

warning off

% get data field names and put them into a string array
names = fieldnames(data);nvars = length(names);
S=names{1};for i=2:nvars;S=[S '|' names{i}];end

figure('Name',['DATA file: ' data.fileName],'units','norm','pos',...
   [.1 .25 .6 .6],'Tag','specfigure')
uimenu('Label','BROWSER:  spectrum screen','fore',[0 0 .8]);
spectra_screen = gcf;

% create the editnum gui and label
sc2 = editnum(gcf,1,length(data.index),1,'INT_SL_B','units','norm',...
    'pos',[.51 .02 .3 .07],'callback','cflag=10;callback',...
    'back',[.85 .9 .85]);
uicontrol('Style','Text','String','record # index','FontWeight','b',...
    'FontSize',10,'pos',[.51 .09 .3 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color'),'fore',[.2 .2 .2]);
% add pushbuttons for +/- 1
scp1 = uicontrol('Style','PushButton','Position',[.81 0.02 .05  .07],'Units','norm',...
    'back',[.85 .85 .85],'String','+1','fore',[.2 .2 .2],'Callback',...
    'cflag=11;callback','FontWeight','b');
scm1 = uicontrol('Style','PushButton','Position',[.46 0.02 .05  .07],'Units','norm',...
    'back',[.85 .85 .85],'String','-1','fore',[.2 .2 .2],'Callback',...
    'cflag=12;callback','FontWeight','b');
% compute number of scene mirror angles
no_sma = length(unique(data.sceneMirrorAngle));
% add pushbuttons for +/- no_sma
scp13 = uicontrol('Style','PushButton','Position',[.86 0.02 .05  .07],'Units','norm',...
    'back',[.85 .85 .85],'String',['+' num2str(no_sma)],'fore',[.2 .2 .2],'Callback',...
    'cflag=15;callback','FontWeight','b');
scm13 = uicontrol('Style','PushButton','Position',[.41 0.02 .05  .07],'Units','norm',...
    'back',[.85 .85 .85],'String',['-' num2str(no_sma)],'fore',[.2 .2 .2],'Callback',...
    'cflag=16;callback','FontWeight','b');

% create clear button
q=uicontrol('Style','PushButton','Position',[.12 0 .1 .05],'Units','norm','back',[0 .7 .7],...
    'String','Clear','fore',[.2 .2 .2],'Callback','cflag=14;callback','FontWeight','b');

% create quit button
q=uicontrol('Style','PushButton','Position',[0 0 .1 .05],'Units','norm','back',[.8 0 0],...
    'String','Quit','fore',[.85 .85 .85],'Callback','cflag=98;callback','FontWeight','b');

% get colors
co = get(gca,'ColorOrder');

% radiance or BT button
RadOrBT1 = uicontrol('Style','PushButton','units','norm','pos',[0 .95 .1 .05],...
    'Callback','cflag=13;callback','back',[0 .7 0],'String','Radiance',...
    'fore',[.2 .2 .2],'FontWeight','b','Value',1);

% initailize 
set(sc2,'Value',1);cflag=10;callback

% add blowup and hold buttons
blowup;blowup(2);holder
nlabels=0;clear labels

% create averaging button
uicontrol('Style','PushButton','units','norm','pos',[.24 .11 .15 .05],...
    'Callback','cflag=110;callback','back',[1 1 1]*.75,'String','Average',...
    'fore','b','FontWeight','b','Value',1,'Tag','averager');

% create spectral resolution button
uicontrol('Style','PushButton','units','norm','pos',[.24 .05 .15 .05],...
    'Callback','cflag=111;callback','back',[1 1 1]*.75,'String','MOPD (cm) :',...
    'fore','b','FontWeight','b','Value',1,'Tag','resolution1');
uicontrol('Style','Edit','units','norm','pos',[.25 .01 .13 .04],...
    'back',[1 1 1]*.75,'String',['def (' num2str(1/(2*mean(diff(data.wnum1)))) ')'],...
    'fore','b','Tag','resolution2');
apod_flag = 0;


